;
; Description: un petit programme qui gnre du code de remplacement pour les divisions
;

;
; Directives de l'assembleur
;
.686P											; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX												; pour activer les instructions mmx
.XMM												; pour activer les instructions sse,sse2
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED										; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP										; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE									; optionel: rends les identifiants sensibles  la casse de caractres


;
; Fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; les equivalences
;
Longueur_Nom				equ 60						;; longueur des noms des fentres

; identifiants des ressources :
Rsrc_IDI_Icone_32				equ 532

Rsrc_IDD_RempDiv_Fenetre			equ 2000
Rsrc_IDC_RempDiv_Fenetre_C		equ 2001
Rsrc_IDC_RempDiv_Entrer_Entier	equ 2002
Rsrc_IDC_RempDiv_Diviseur		equ 2003
Rsrc_IDC_RempDiv_Selectionnez		equ 2004
Rsrc_IDC_RempDiv_Prog_Cible		equ 2005
Rsrc_IDC_RempDiv_Transferer		equ 2006
Rsrc_IDC_RempDiv_Code_Remplacement	equ 2007

Rsrc_IDD_Insuffisant			equ 2100
Rsrc_IDC_Insuffisant_C			equ 2101
Rsrc_IDC_Desole				equ 2102
Rsrc_IDC_Temps_Changer			equ 2103

Rsrc_IDD_Quitter				equ 2200
Rsrc_IDC_Quitter_C				equ 2201
Rsrc_IDC_Vraiment_quitter		equ 2202
Rsrc_IDC_Hum_Oui				equ 2203
Rsrc_IDC_Ah_Ca_Non				equ 2204


;
; PROTOS
;
GestionnaireMessagesBoiteDialogueRemplacementDivision	PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoitesDialogue			PROTO :DWORD,:DWORD,:DWORD,:DWORD


.DATA
;
; STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT							;; pour un total de 16 octets
	_Instance_			DWORD ?						;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?						;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?						;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT									;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?						;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?						;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?						;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS


; cette structure n'est l qu'a titre d'information, c'est sous cette forme que se prsente la suite de structures
; de notre bloc mmoire pour la recherche des autres fentres/applications
_Tampon_Chaines_Fenetres_ STRUC
	_Nom_Fenetre_			BYTE Longueur_Nom dup (?)
	_Pointeur_			DWORD ?
;	_Nom_Classe_			BYTE Longueur_Nom dup (?)
_Tampon_Chaines_Fenetres_ ENDS


.DATA
ALIGN 16
;
; CONSTANTES et VARIABLES
;
Instance_Application			DWORD ?
Instance_Boite_Dialogue_Principale	DWORD ?
Instance_Boites_Dialogue			DWORD ?
Temoins_Boites_De_Dialogue		DWORD ?
Pointeur_Ligne_Commandes			DWORD ?

Chaine_Selectionnez_La_Cible		BYTE " Slectionnez la cible ->",0
Chaine_Rappel_Selectionner_Cible	BYTE 13,10," On vous a dit qu'il fallait slectionner une cible !",0


RempDiv_Adresse_Temporaire			DWORD ?							;; servira pour l'adresse des chanes variantes

RempDiv_Pointeur_Premiere_Fenetre		DWORD ?
RempDiv_Pointeur_Derniere_Fenetre		DWORD ?
RempDiv_Pointeur_Fenetre_Selectionnee	DWORD ?

RempDiv_Choix_Programme_Cible			DWORD ?
;RempDiv_Temoin_Programme_Cible		BYTE ?

RempDiv_Nombre_De_Fenetres			DWORD ?
RempDiv_Compteur_Temporaire			DWORD ?

RempDiv_Temoins_Bloc_Chaines_Fenetres	BYTE 0
RempDiv_Tampon_Texte				BYTE 2048 dup (?)

RempDiv_Chaine_Diviseur				BYTE "___________",0
RempDiv_Chaine_Multiplicateur_Magique_1	BYTE "___________",0
RempDiv_Chaine_Multiplicateur_Magique_2	BYTE "___________",0
RempDiv_Chaine_Decalage				BYTE "___________",0

; chaine d'information concernant l'usage
RempDiv_Chaine_Usage				BYTE "				NightWare ",13,10
								BYTE " Code assembleur de subtitution aux divisions v 1.0",13,10,13,10
								BYTE " 1) slectionner la fentre cible/destination.",13,10,13,10
								BYTE " 2) entrer le diviseur dsir, ce qui gnrera le code",13,10
								BYTE " de substitution, qui remplacera avantageusement la",13,10
								BYTE " trs lente instruction DIV.",13,10,13,10
								BYTE " 3) cliquer sur transfrer pour envoyer le code obtenu",13,10
								BYTE " dans la fentre cible.",13,10,13,10
								BYTE " On fait difficilement plus simple, non ?",13,10,0

; texte  afficher en cas de division par 0
RempDiv_Chaine_Division_Par_0			BYTE "La valeur entre est 0, ou n'est pas valide, c'est donc",13,10
								BYTE "considr comme un 0.",13,10,13,10
								BYTE "Et, petit rappel :",13,10
								BYTE "En mathmatiques, la division par 0 n'existe pas !",13,10,0

; texte  afficher en cas de division par 1
RempDiv_Chaine_Division_Par_1			BYTE "??? hum... tu m'as l'air particulirement dou toi...",13,10,13,10
								BYTE "Diviser par 1 ? ben, pas besoin de code pour a, parceque,",13,10
								BYTE "que tu le crois ou non, ca se fait tout seul...",13,10,0

; texte  afficher en cas de division par une puisssance de 2
RempDiv_Chaine_Debut_Puissance_De_2	BYTE "; Le diviseur est une puissance de 2. Aussi, pour remplacer une division par ",0
RempDiv_Chaine_Suite_Puissance_De_2	BYTE ", utilisez le code de remplacement :",13,10
								BYTE "		mov eax,ValeursADiviser							;; placer la valeur  diviser dans eax",13,10
								BYTE "		shr eax,",0
RempDiv_Chaine_Fin_Puissance_De_2		BYTE "										;; Utiliser sar au lieu de shr, si la valeur  diviser est signe",13,10
								BYTE "; Ici, la partie entire de la division se situe dans eax.",13,10,0

; texte  afficher en cas de division si ce n'est pas une puissance de 2
RempDiv_Chaine_Entete				BYTE "; Pour remplacer une division par ",0
RempDiv_Chaine_Entete_Suite			BYTE ", utilisez le code de remplacement :",13,10,13,10
								BYTE "; Methode 1 : cette methode permet d'obtenir des multiplicateurs 'magiques' plus rapides, mais ceux-ci manquent de",13,10
								BYTE "; prcision (arrondis) lorsqu'au moins une des 2 valeurs est leve. c'est vrifi sans erreurs lorsque la valeur",13,10
								BYTE ";  diviser va de 0  65536, et que le diviseur va de de 2  65536 (0 et 1, doivent tre traits autrement).",13,10
								BYTE "		mov eax,ValeursADiviser							;; placer la valeur  diviser dans eax",13,10
								BYTE "		mov edx,",0

RempDiv_Chaine_Transition			BYTE "								;; placer le multiplicateur magique dans edx",13,10
								BYTE "		mul edx										;; effectuer la multiplication",13,10
								BYTE "; Ici, la partie entire de la division se situe dans edx.",13,10,13,10
								BYTE "; Methode 2 : en gros c'est idem  la methode 1, sauf qu'un dcalage est pratiqu au pralable sur la valeur ",13,10
								BYTE "; diviser, et un dcalage est ensuite pratiqu sur le rsultat (c'est un peu plus lent, mais ca augmente beaucoup",13,10
								BYTE "; la prcision du rsultat obtenu, et l encore 0 et 1, doivent tre traits autrement).",13,10
								BYTE "		mov eax,ValeursADiviser							;; placer la valeur  diviser dans eax",13,10,0

RempDiv_Chaine_Variante_1			BYTE "		mov edx,",0

RempDiv_Chaine_Variante_2			BYTE "		inc eax										;; (ici, add eax,1 est peut tre plus rapide (il faut tester))",13,10
								BYTE "		mov edx,",0

RempDiv_Chaine_Multiplication			BYTE "								;; placer le multiplicateur magique dans edx",13,10
								BYTE "		mul edx										;; effectuer la multiplication",13,10
								BYTE "		shr edx,",0

RempDiv_Chaine_De_Fin				BYTE "										;; pratiquer un dcalage pour obtenir le bon rsultat",13,10
								BYTE "; Ici, la partie entire de la division se situe dans edx.",13,10,0


ALIGN 16
; variables structures
Instance_Memoire				_Informations_Memoire_ <?>
RempDiv_Tampon_Chaines_Fenetres	_Bloc_Memoire_ <?>

RempDiv_Coordonnees_Fenetre		RECT <?>					;; 4 Dwords (x,y du coin suprieur gauche et x,y du coin infrieur droit)
Informations_Messages_OS			MSG <?>					;; 5 Dwords + 2 Words


.CODE
;
; Macros
;


.CODE
;
; les procdures gnriques
;
INCLUDE GenericProcs.inc


.CODE
;
; les procdures spcifiquement cres pour le programme
;

ALIGN 16
;
; PROCEDURE DE GESTION DES MESSAGES WINDOWS
;
GestionnaireMessagesBoiteDialogueRemplacementDivision PROC HWndGMDiv:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

; INITDIALOG
		cmp eax,WM_INITDIALOG							;; comparer eax  WM_INITDIALOG
		jne GMDivEviterInitialiserBoiteDeDialogue			;; si ce n'est pas le cas, aller GMDivEviterInitialiserBoiteDeDialogue
		invoke LoadIcon,HWndGMDiv,Rsrc_IDI_Icone_32			;;
		invoke SetClassLong,HWndGMDiv,GCL_HICON,eax			;;

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		mov esi,HWndGMDiv								;; ) positionner la fentre outil
		mov edi,OFFSET RempDiv_Coordonnees_Fenetre			;; )
		call PositionnerFenetreOutil						;; )

; ici, c'est histoire d'viter les mauvaises surprises
		mov eax,HWndGMDiv								;; ) recopier le pointeur de notre fentre dans celle slectionne
		mov RempDiv_Pointeur_Fenetre_Selectionnee,eax		;; )

; ici, c'est pour faire apparatre "slectionnez la cible ->" dans la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_RESETCONTENT,0,0		;; vider la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_ADDSTRING,0,ADDR Chaine_Selectionnez_La_Cible		;; dfinir la ligne dans la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SETCURSEL,0,ADDR Chaine_Selectionnez_La_Cible		;; l'afficher
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SHOWDROPDOWN,0,TRUE		;; et activer la slection

; dsactiver le bouton pour transfrer
		invoke GetDlgItem,HWndGMDiv,Rsrc_IDC_RempDiv_Transferer		;; obtenir les info de l'ID
		invoke EnableWindow,eax,FALSE						;; dsactiver le control correspondant

; ici, on fait apparatre la chaine d'information concernant l'usage
		mov eax,OFFSET RempDiv_Chaine_Usage				;; placer l'adresse de la chane d'information dans eax
		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,eax		;; et l'afficher par dfaut

	ret												;; retourner
GMDivEviterInitialiserBoiteDeDialogue:


;
; ici, les commandes gnres par la souris sur les menus, ou les controlleurs, grs par windows...
;
		cmp eax,WM_COMMAND								;; une commande est entre ?
		jne GMDivFinCommandes							;; si ce n'est pas le cas, aller GMDivFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;

;
; slectionner le programme cible (boite combo)
;
		mov edx,eax									;; copier eax dans edx
		and edx,0FFFFh									;; conserver le word infrieur de edx
		cmp edx,Rsrc_IDC_RempDiv_Prog_Cible				;; boite combo ?
		jne GMDivPasSelectionnerCible						;; si ce n'est pas le cas, aller GMDivPasSelectionnerCible
		mov edx,eax									;; copier eax dans edx
		shr edx,16									;; conserver le word suprieur de eax

;
; un programme est slectionn dans la boite ?
;
		cmp edx,CBN_SELENDOK							;; une ligne est slectionne ?
		jne GMDivMiseAJourListeProgrammes					;; si ce n'est pas le cas, aller GMDivMiseAJourListeProgrammes
; sinon, on lit le nom de l'application slectionne, et on sauvegarde le numro du choix obtenu
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_GETCURSEL,0,0
		mov RempDiv_Choix_Programme_Cible,eax				;; on sauvegarde le numro du choix obtenu

;		mov eax,RempDiv_Choix_Programme_Cible				;; placer le numro du choix dans eax
		mov edx,Longueur_Nom+DWORD						;; placer 60+4 dans edx
		mul edx										;; multiplier
		add eax,Longueur_Nom							;; ajouter 60
		add eax,RempDiv_Tampon_Chaines_Fenetres._Pointeur_		;; ajouter l'adresse de dpart des noms des fentres trouves
;		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SETCURSEL,0,Choix_Programme_Cible
		mov eax,DWORD PTR [eax]							;; placer le pointeur (handle) de la fentre slectionne dans eax
		mov RempDiv_Pointeur_Fenetre_Selectionnee,eax		;; et le sauvegarder dans RempDiv_Pointeur_Fenetre_Selectionnee

; activer le bouton pour transfrer
		invoke GetDlgItem,HWndGMDiv,Rsrc_IDC_RempDiv_Transferer		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
;		mov RempDiv_Temoin_Programme_Cible,1				;; placer le tmoin spcifiant qu'un programme est cibl

	ret
GMDivMiseAJourListeProgrammes:

;
; clic sur la boite ?
;
		cmp edx,CBN_DROPDOWN							;; on veut lister les programme ?
		jne GMDivPasSelectionnerCible						;; si ce nest pas le cas, aller GMDivPasSelectionnerCible

; la fentre de notre application est normalement la plus haute (highest), puisqu'on  cliqu sur un contrleur,
; mais on va tout de mme chercher la plus haute
		invoke GetWindow,HWndGMDiv,GW_HWNDFIRST				;; ) dfinir la premire fentre (higest)
		mov RempDiv_Pointeur_Premiere_Fenetre,eax			;; )
		invoke GetWindow,HWndGMDiv,GW_HWNDLAST				;;	) dfinir la dernire fentre (lowest)
		mov RempDiv_Pointeur_Derniere_Fenetre,eax			;;	)
; dfinir le nombre de fentres
		mov esi,RempDiv_Pointeur_Premiere_Fenetre			;; placer le pointeur de la fentre la plus haute dans esi
		mov RempDiv_Compteur_Temporaire,2					;; initialiser notre compteur en placant 2 dedans (la fentre en cours de traitement+program manager)
GMDivBoucleEnumeration:
		invoke GetWindow,esi,GW_HWNDNEXT					;; obtenir le pointeur suivant
		cmp eax,RempDiv_Pointeur_Derniere_Fenetre			;; c'est la dernire fentre ?
		je GMDivFinBoucleEnumeration						;; si c'est le cas, aller GMDivFinBoucleEnumeration
		test eax,eax									;; ) test d'existence d'une fentre
		jz GMDivFinBoucleEnumeration						;; )
		mov esi,eax									;; si une fentre existe, placer le nouveau pointeur dans esi
		inc RempDiv_Compteur_Temporaire					;; incrmenter notre compteur
		jmp GMDivBoucleEnumeration						;; et aller GMDivBoucleEnumeration
GMDivFinBoucleEnumeration:
; vider la mmoire (si un bloc  t cr prcdemment)
		cmp RempDiv_Temoins_Bloc_Chaines_Fenetres,0			;; tester le temoin pour le bloc mmoire
		je GMDivEviterPurgerMemoire						;; si c'est inutilis, aller GMDivEviterPurgerMemoire
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour les chanes relatives aux fentres
		mov edi,OFFSET RempDiv_Tampon_Chaines_Fenetres		;; )
		call LibererBlocMemoire							;; )
GMDivEviterPurgerMemoire:
		mov eax,Longueur_Nom+DWORD						;; placer 60+4 dans eax
		mul RempDiv_Compteur_Temporaire					;; multiplier par le nombre de fentres trouv
		mov esi,OFFSET Instance_Memoire					;; ) crer le bloc mmoire correspondant
		mov edi,OFFSET RempDiv_Tampon_Chaines_Fenetres		;; )
		call AllouerBlocMemoire							;; )
		mov RempDiv_Temoins_Bloc_Chaines_Fenetres,1			;; placer le tmoin d'utilisation d'un bloc mmoire pour les chanes
		mov RempDiv_Nombre_De_Fenetres,0					;; remettre le nombre de fentres  zro
		mov esi,RempDiv_Pointeur_Premiere_Fenetre			;; placer le pointeur de la fentre la plus haute dans esi
		mov edi,RempDiv_Tampon_Chaines_Fenetres._Pointeur_		;; placer l'adresse de dpart des chanes dans edi
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_RESETCONTENT,0,0		;; vider la boite combo (parcequ'on va la remplir...)
GMDivBoucleRecuperation:
		invoke GetWindowText,esi,edi,Longueur_Nom-1			;; obtenir le nom de la fentre (60-1 pour tre sr qu'il y aura un zro final)
		cmp BYTE PTR [edi],0							;; il n'y a pas de nom ?
		je GMDivEviterRecuperation						;; si c'est le cas, la fentre n'est pas utilisable, donc on evite le traitement...
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_ADDSTRING,0,edi		;; sinon on dfini une nouvelle ligne dans la boite combo
		add edi,Longueur_Nom							;; ajouter 60  edi
		mov DWORD PTR [edi],esi							;; placer le pointeur de la fentre dans le bloc mmoire
		add edi,DWORD									;; et ajouter un dword  l'adresse en edi
;		invoke GetClassName,esi,edi,Longueur_Nom-1			;; obtenir le nom de la classe de fentre (ca reservira...)
;		add edi,Longueur_Nom							;; ajouter 60  edi
		inc RempDiv_Nombre_De_Fenetres					;; incrmenter le nombre de fenetres utilisable
GMDivEviterRecuperation:
		invoke GetWindow,esi,GW_HWNDNEXT					;; ) placer le pointeur suivant dans esi
		mov esi,eax									;; )
		dec RempDiv_Compteur_Temporaire					;; dcrmenter le compteur de fentre
		jnz GMDivBoucleRecuperation						;; tant que le compteur est diffrent de 0, aller GMDivBoucleRecuperation
GMDivFinBoucleRecuperation:
		mov RempDiv_Choix_Programme_Cible,-1				;; on sauvegarde le numro du choix obtenu

;; dfinir la premire selection
;		sub edi,Longueur_Nom+DWORD						;; placer 60*+4 dans eax
;		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SETCURSEL,0,edi
;		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SHOWDROPDOWN,0,TRUE

	ret												;; retourner
GMDivPasSelectionnerCible:

;
; si ce n'est ni CBN_SELENDOK, ni CBN_DROPDOWN, alors on va tester s'il faut remettre "slectionnez la cible ->"
; dans la boite combo
;
		cmp RempDiv_Choix_Programme_Cible,0				;; tester le choix effectu
		jge GMPasInitialiserSelection						;; si c'est positif, aller GMPasInitialiserSelection
; ici, c'est pour faire apparatre "slectionnez la cible ->" dans la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_RESETCONTENT,0,0		;; vider la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_ADDSTRING,0,ADDR Chaine_Selectionnez_La_Cible		;; dfinir la ligne dans la boite combo
		invoke SendDlgItemMessage,HWndGMDiv,Rsrc_IDC_RempDiv_Prog_Cible,CB_SETCURSEL,0,ADDR Chaine_Selectionnez_La_Cible		;; l'afficher
; dsactiver le bouton pour transfrer
		invoke GetDlgItem,HWndGMDiv,Rsrc_IDC_RempDiv_Transferer		;; obtenir les info de l'ID
		invoke EnableWindow,eax,FALSE						;; dsactiver le control correspondant
;		mov RempDiv_Temoin_Programme_Cible,0				;; placer le tmoin spcifiant qu'aucun programme n'est cibl
; ici, c'est histoire d'viter les mauvaises surprises
		mov eax,HWndGMDiv								;; ) recopier le pointeur de notre fentre dans celle slectionne
		mov RempDiv_Pointeur_Fenetre_Selectionnee,eax		;; )
; restaurer WParam
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
GMPasInitialiserSelection:


;
; entier entr
;
		mov edx,eax									;; copier eax dans edx
		and edx,0FFFFh									;; conserver le word infrieur de eax
		cmp edx,Rsrc_IDC_RempDiv_Diviseur					;; entier entr ?
		jne GMDivPasEntreeEntier							;; si ce n'est pas le cas, aller GMDivPasEntreeEntier
		mov edx,eax									;; copier eax dans edx
		shr edx,16									;; conserver le word suprieur de eax
		cmp edx,EN_CHANGE								;; une modification a t efectue ?
;		cmp edx,EN_UPDATE								;; une modification a t efectue ?
		jne GMDivPasEntreeEntier							;; si ce n'est pas le cas, aller GMDivPasEntreeEntier

; Obtenir le diviseur entr
		invoke GetDlgItemInt,HWndGMDiv,Rsrc_IDC_RempDiv_Diviseur,NULL,FALSE		;; obtenir l'entier qui doit servir de diviseur
		test eax,eax									;; fixer les flags de eax
		je GMDivDivisionPar0							;; si c'est gal  0, aller GMDivDivisionPar0
		cmp eax,1										;; comparer eax  1
		je GMDivDivisionPar1							;; si c'est gal, aller GMDivDivisionPar1
		mov esi,OFFSET RempDiv_Chaine_Diviseur				;; ) sinon, convertir le diviseur en eax en chane ascii dans RempDiv_Chaine_Diviseur
		call ConvertirValeurEnChaineDecimale				;; )
; tester si le diviseur est une puissance de 2
		bsr ecx,eax									;; trouver le premier bit positionn en eax en commencant par le bit 31
		bsf edx,eax									;; trouver le premier bit positionn en eax en commencant par le bit 0
		cmp edx,ecx									;; edx et ecx sont identiques ? alors c'est qu'il n'y a qu'un seul bit positionn (et donc la valeur en eax est une puissance de 2)
		je GMDivCasPuissanceDe2							;; si c'est le cas, aller GMDivCasPuissanceDe2

;
; ici, les cas o le diviseur n'est pas une puissance de 2
;
GMDivCasNonPuissanceDe2:
; la methode 1 :
		mov ebx,eax									;; placer le diviseur dans ebx
		call ObtenirMultiplicateurMagique					;; et obtenir sa correspondance multiplicatrice
		mov esi,OFFSET RempDiv_Chaine_Multiplicateur_Magique_1		;; ) convertir la valeur en eax en chane ascii dans RempDiv_Chaine_Multiplicateur_Magique_1
		call ConvertirValeurEnChaineDecimale				;; )

; la methode 2 :
;		mov ebx,eax									;; placer le diviseur dans ebx
		call ObtenirMultiplicateurMagiquePrecis				;; et obtenir sa correspondance multiplicatrice
		mov esi,OFFSET RempDiv_Chaine_Multiplicateur_Magique_2		;; ) convertir la valeur en eax en chane ascii dans RempDiv_Chaine_Multiplicateur_Magique_2
		call ConvertirValeurEnChaineDecimale				;; )
		test edx,edx									;; fixer les flags de edx (pour savoir quel algo utiliser)
		jnz GMDivUtilisationAlgorithme2					;; si c'est diffrent de 0 (variante 2), aller GMDivUtilisationAlgorithme2
		mov eax,OFFSET RempDiv_Chaine_Variante_1			;; sinon, placer l'adresse de RempDiv_Chaine_Variante_1 dans eax
		mov RempDiv_Adresse_Temporaire,eax					;; et la placer dans RempDiv_Adresse_Temporaire
		jmp GMDivUtilisationAlgorithme1					;; aller GMDivUtilisationAlgorithme1
GMDivUtilisationAlgorithme2:
		mov eax,OFFSET RempDiv_Chaine_Variante_2			;; placer l'adresse de RempDiv_Chaine_Variante_2 dans eax
		mov RempDiv_Adresse_Temporaire,eax					;; et la placer dans RempDiv_Adresse_Temporaire
GMDivUtilisationAlgorithme1:
		mov eax,ecx									;; ) convertir le dcalage en ecx en chane ascii dans RempDiv_Chaine_Decalage
		mov esi,OFFSET RempDiv_Chaine_Decalage				;; )
		call ConvertirValeurEnChaineDecimale				;; )

; il ne reste plus qu'a construire le texte
		mov edi,OFFSET RempDiv_Tampon_Texte				;; placer l'adresse du tampon dans edi
		mov BYTE PTR [edi],0							;; placer 0 dans RempDiv_Tampon_Texte (pour indiquer qu'il n'y a pas de texte pour le moment...)
		invoke FusionnerMultiplesChainesAscii,10,ADDR RempDiv_Chaine_Entete,ADDR RempDiv_Chaine_Diviseur,ADDR RempDiv_Chaine_Entete_Suite,ADDR RempDiv_Chaine_Multiplicateur_Magique_1,ADDR RempDiv_Chaine_Transition,RempDiv_Adresse_Temporaire,ADDR RempDiv_Chaine_Multiplicateur_Magique_2,ADDR RempDiv_Chaine_Multiplication,ADDR RempDiv_Chaine_Decalage,ADDR RempDiv_Chaine_De_Fin
		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,ADDR RempDiv_Tampon_Texte		;; afficher le rsultat
	ret												;; retourner

;
; ici, les cas o le diviseur est une puissance de 2
;
GMDivCasPuissanceDe2:
		mov eax,ecx									;; placer la valeur de dcalage dans eax
		mov esi,OFFSET RempDiv_Chaine_Decalage				;; ) convertir la valeur en eax en chane ascii dans RempDiv_Chaine_Decalage
		call ConvertirValeurEnChaineDecimale				;; )

; il ne reste plus qu'a construire le texte
		mov edi,OFFSET RempDiv_Tampon_Texte				;; placer l'adresse du tampon dans edi
		mov BYTE PTR [edi],0							;; placer 0 dans RempDiv_Tampon_Texte (pour indiquer qu'il n'y a pas de texte pour le moment...)
		invoke FusionnerMultiplesChainesAscii,5,ADDR RempDiv_Chaine_Debut_Puissance_De_2,ADDR RempDiv_Chaine_Diviseur,ADDR RempDiv_Chaine_Suite_Puissance_De_2,ADDR RempDiv_Chaine_Decalage,ADDR RempDiv_Chaine_Fin_Puissance_De_2
		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,ADDR RempDiv_Tampon_Texte		;; afficher le rsultat
	ret												;; retourner

;
; ici, tentative de division par 1
;
GMDivDivisionPar1:
		mov esi,OFFSET RempDiv_Chaine_Division_Par_1			;; placer l'adresse du texte pour la division par 1 dans esi
		mov edi,OFFSET RempDiv_Tampon_Texte				;; placer l'adresse du tampon dans edi
		mov BYTE PTR [edi],0							;; placer 0 dans RempDiv_Tampon_Texte (pour indiquer qu'il n'y a pas de texte pour le moment...)
		call CopierChaineAscii							;; et copier la chane dans RempDiv_Tampon_Texte
;		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Diviseur,0		;; ) nettoyer l'affichage
		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,ADDR RempDiv_Tampon_Texte		;; afficher le rsultat
	ret												;; retourner

;
; ici, tentative de division par 0, ou par une valeur invalide...
;
GMDivDivisionPar0:
		mov esi,OFFSET RempDiv_Chaine_Division_Par_0			;; placer l'adresse du texte pour la division par 0 dans esi
		mov edi,OFFSET RempDiv_Tampon_Texte				;; placer l'adresse du tampon dans edi
		mov BYTE PTR [edi],0							;; placer 0 dans RempDiv_Tampon_Texte (pour indiquer qu'il n'y a pas de texte pour le moment...)
		call CopierChaineAscii							;; et copier la chane dans RempDiv_Tampon_Texte
;		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Diviseur,0		;; ) nettoyer l'affichage
		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,ADDR RempDiv_Tampon_Texte		;; afficher le rsultat
	ret												;; retourner

;
	ret												;; retourner
GMDivPasEntreeEntier:


;
; transfrer
;
		cmp eax,Rsrc_IDC_RempDiv_Transferer				;; transfrer ?
		jne GMDivPasTransferer							;; si ce n'est pas le cas, aller GMDivPasTransferer

;; un programme cible existe ?
;		cmp RempDiv_Temoin_Programme_Cible,1				;; un programme est cibl ?
;		jne GMDivPasDeCibleSelectionnee					;; si ce n'est pas le cas, aller GMDivPasDeCibleSelectionnee
; sinon, on transfre
		mov eax,RempDiv_Pointeur_Fenetre_Selectionnee		;; placer le pointeur de la fentre cible dans eax
		mov esi,OFFSET RempDiv_Tampon_Texte				;; placer l'adresse de la chane  tranfrer dans esi
		call Clipboard_InjecterChaineAscii					;; et transfrer
	ret												;; retourner

;GMDivPasDeCibleSelectionnee:
;		mov eax,OFFSET Chaine_Rappel_Selectionner_Cible		;; placer l'adresse de la chane de rappel de slection de la cible
;		invoke SetDlgItemText,HWndGMDiv,Rsrc_IDC_RempDiv_Code_Remplacement,eax		;; et afficher la chane de caractres correspondante
;	ret												;; retourner
GMDivPasTransferer:

;
	ret												;; retourner
GMDivFinCommandes:


;
; fermeture de l'application ?
;
		cmp eax,WM_CLOSE								;; message de fermeture reu ?
		jne GMDivFinFermeture							;; si ce n'est pas le cas, aller GMDivFinFermeture
		jmp GMDivSortir								;; aller GMDivSortir
	ret												;; retourner
GMDivFinFermeture:


;
; fin du processus principal
;
		cmp eax,WM_DESTROY								;; fermeture de l'application par la croix ?
		jne GMDivFinProcessusTermine						;; si c'est diffrent, aller GMDivFinProcessusTermine
GMDivSortir:
		bts Temoins_Boites_De_Dialogue,0					;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EnableWindow,HWndGMDiv,FALSE
;		invoke EndDialog,HWndGMDiv,0						;; sinon, fermer la boite de dialogue
;		invoke CloseHandle,HWndGMDiv
;		invoke DestroyWindow,HWndGMDiv
;		invoke Sleep,20
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMDiv,TRUE
	ret												;; retourner
GMDivFinProcessusTermine:


;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoiteDialogueRemplacementDivision ENDP


ALIGN 16
;
; gestionnaire de message pour les boites de dialogue supplmentaires
;
GestionnaireMessagesBoitesDialogue PROC HWndGMBD:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

		cmp eax,WM_COMMAND								;; une commande ?
		jne GMBDFinCommandes							;; si ce n'est pas le cas, aller GMBDFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer					;; Il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro						;; si ce n'est pas le cas, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui							;; Hum... oui est cliqu ?
		jne GMBDPasHumOui								;; si ce n'est pas le cas, aller GMBDPasHumOui
		btr Temoins_Boites_De_Dialogue,0					;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; poster le message de sortie
	ret												;; retourner
GMBDPasHumOui:
; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non						;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon								;; si ce n'est pas le cas, aller GMBDPasAhCaNon
		btr Temoins_Boites_De_Dialogue,0					;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
;		invoke CloseHandle,HWndGMBD
;		invoke DestroyWindow,HWndGMBD

;		invoke Sleep,20
;		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_RempDiv_Fenetre,0,ADDR GestionnaireMessagesBoiteDialogueRemplacementDivision,0
	ret												;; retourner
GMBDPasAhCaNon:


;
	ret												;; retourner
GMBDFinCommandes:


; traitement par dfaut pour les boites de dialogue
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoitesDialogue ENDP



;
.CODE
;
; PROGRAMME PRINCIPAL
;

RemplacerDivisions:
; initialisation
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax					;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commandes
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax						;; ) et sauvegarder le pointeur obtenu dans Instance_Application
;		mov Informations_Fenetre.hInstance,eax				;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue_Principale,eax			;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue_Principale
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance des boites de dialogue
		mov Instance_Boites_Dialogue,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Boites_Dialogue
		mov esi,OFFSET Instance_Memoire					;;	) obtenir une instance mmoire
		call CreerInstanceMemoire						;;	)
;		call InitialiserNombresAleatoires					;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
;		mov eax,_Temoins_Aptitudes_Du_MicroProcesseur_		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000010011b							;; cpuid + fpu + cmov
;		mov edx,000001010011b							;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b							;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant						;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
;		invoke ReleaseCapture							;; librer les messages de la souris
;		invoke ShowCursor,Vrai							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoitesDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je MicroprocesseurInsuffisant						;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoitesDialogue au moment voulu)
		jmp MicroprocesseurBoucleMessages					;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent
;

;
; appeler la boite de dialogue principale
;
		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_RempDiv_Fenetre,0,ADDR GestionnaireMessagesBoiteDialogueRemplacementDivision,0


;
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
;
BoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je FinBoucleMessages							;; si c'est gal  0 (pas de message), aller FinBoucleMessages
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoiteDialogueRemplacementDivision au moment voulu)
		jmp BoucleMessages								;; aller BoucleMessages (pour aller lire le message suivant)
FinBoucleMessages:


;
; vider la mmoire (si un bloc  t cr)
;
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour les chanes relatives aux fentres
		cmp RempDiv_Temoins_Bloc_Chaines_Fenetres,0			;; tester le temoin pour le bloc mmoire
		je EviterViderMemoire							;; si c'est inutilis, aller EviterViderMemoire
;		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour les chanes relatives aux fentres
		mov edi,OFFSET RempDiv_Tampon_Chaines_Fenetres		;; )
		call LibererBlocMemoire							;; )
EviterViderMemoire:


;
; et par ici la sortie...
;
MicroprocesseurInsuffisant:
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'intance mmoire
		call SupprimerInstanceMemoire						;; )
		invoke ExitProcess,Informations_Messages_OS.wParam		;; sortie de l'application
;
; fin du programme
;
END RemplacerDivisions

